Loading...
Searching...
No Matches
itk::GPUInPlaceImageFilter< TInputImage, TOutputImage, TParentImageFilter > Class Template Reference

`#include <itkGPUInPlaceImageFilter.h>`

## Detailed Description

template<typename TInputImage, typename TOutputImage = TInputImage, typename TParentImageFilter = InPlaceImageFilter<TInputImage, TOutputImage>>
class itk::GPUInPlaceImageFilter< TInputImage, TOutputImage, TParentImageFilter >

Base class for GPU filters that take an image as input and overwrite that image as the output.

This class is the base class for GPU inplace filter. The template parameter for parent class type must be InPlaceImageFilter type so that the GPU superclass of this class can be correctly defined (NOTE: TParentImageFilter::Superclass is used to define GPUImageToImageFilter class).

Note
  This file was taken from ITK 4.1.0. It was modified by Denis P. Shamonin and Marius Staring. Division of Image Processing, Department of Radiology, Leiden, The Netherlands. Added functionality is described in the Insight Journal paper: http://hdl.handle.net/10380/3393

Definition at line 62 of file itkGPUInPlaceImageFilter.h.

Inheritance diagram for itk::GPUInPlaceImageFilter< TInputImage, TOutputImage, TParentImageFilter >:
[legend]

## Public Types

using | ConstPointer = SmartPointer<const Self>
using | CPUSuperclass = TParentImageFilter
using | GPUSuperclass = GPUImageToImageFilter<TInputImage, TOutputImage, TParentImageFilter>
using | InputImageConstPointer = typename InputImageType::ConstPointer
using | InputImagePixelType = typename InputImageType::PixelType
using | InputImagePointer = typename InputImageType::Pointer
using | InputImageRegionType = typename InputImageType::RegionType
using | InputImageType = TInputImage
using | OutputImagePixelType = typename GPUSuperclass::OutputImagePixelType
using | OutputImagePointer = typename GPUSuperclass::OutputImagePointer
using | OutputImageRegionType = typename GPUSuperclass::OutputImageRegionType
using | OutputImageType = typename GPUSuperclass::OutputImageType
using | Pointer = SmartPointer<Self>
using | Self = GPUInPlaceImageFilter
Public Types inherited from itk::GPUImageToImageFilter< TInputImage, TOutputImage, TParentImageFilter >
using | ConstPointer = SmartPointer<const Self>
using | InputImageConstPointer = typename InputImageType::ConstPointer
using | InputImagePixelType = typename InputImageType::PixelType
using | InputImagePointer = typename InputImageType::Pointer
using | InputImageRegionType = typename InputImageType::RegionType
using | InputImageType = TInputImage
using | OutputImageType = TOutputImage
using | Pointer = SmartPointer<Self>
using | Self = GPUImageToImageFilter
using | Superclass = TParentImageFilter

## Public Member Functions

virtual const char * | GetClassName () const
| ITK_DISALLOW_COPY_AND_MOVE (GPUInPlaceImageFilter)
| itkStaticConstMacro (InputImageDimension, unsigned int, TInputImage::ImageDimension)
| itkStaticConstMacro (OutputImageDimension, unsigned int, TOutputImage::ImageDimension)
Public Member Functions inherited from itk::GPUImageToImageFilter< TInputImage, TOutputImage, TParentImageFilter >
virtual bool | GetGPUEnabled () const
virtual void | GPUEnabledOff ()
virtual void | GPUEnabledOn ()
void | GraftOutput (const DataObjectIdentifierType &key, DataObject *graft) override
void | GraftOutput (DataObject *graft) override
| ITK_DISALLOW_COPY_AND_MOVE (GPUImageToImageFilter)
| itkStaticConstMacro (InputImageDimension, unsigned int, TInputImage::ImageDimension)
| itkStaticConstMacro (OutputImageDimension, unsigned int, TOutputImage::ImageDimension)
virtual void | SetGPUEnabled (bool _arg)
void | SetNumberOfWorkUnits (ThreadIdType _arg) override

## Protected Member Functions

void | AllocateOutputs () override
| GPUInPlaceImageFilter ()=default
void | PrintSelf (std::ostream &os, Indent indent) const override
void | ReleaseInputs () override
| ~GPUInPlaceImageFilter () override=default
Protected Member Functions inherited from itk::GPUImageToImageFilter< TInputImage, TOutputImage, TParentImageFilter >
void | GenerateData () override
virtual void | GPUGenerateData ()
| GPUImageToImageFilter ()
void | PrintSelf (std::ostream &os, Indent indent) const override
| ~GPUImageToImageFilter () override=default

## Additional Inherited Members

Static Public Member Functions inherited from itk::GPUImageToImageFilter< TInputImage, TOutputImage, TParentImageFilter >
static Pointer | New ()
Protected Attributes inherited from itk::GPUImageToImageFilter< TInputImage, TOutputImage, TParentImageFilter >
OpenCLKernelManager::Pointer | m_GPUKernelManager {}

## Member Typedef Documentation

## ConstPointer

template<typename TInputImage, typename TOutputImage = TInputImage, typename TParentImageFilter = InPlaceImageFilter<TInputImage, TOutputImage>>

using itk::GPUInPlaceImageFilter< TInputImage, TOutputImage, TParentImageFilter >::ConstPointer = SmartPointer<const Self>

Definition at line 73 of file itkGPUInPlaceImageFilter.h.

## CPUSuperclass

template<typename TInputImage, typename TOutputImage = TInputImage, typename TParentImageFilter = InPlaceImageFilter<TInputImage, TOutputImage>>

using itk::GPUInPlaceImageFilter< TInputImage, TOutputImage, TParentImageFilter >::CPUSuperclass = TParentImageFilter

Definition at line 71 of file itkGPUInPlaceImageFilter.h.

## GPUSuperclass

template<typename TInputImage, typename TOutputImage = TInputImage, typename TParentImageFilter = InPlaceImageFilter<TInputImage, TOutputImage>>

using itk::GPUInPlaceImageFilter< TInputImage, TOutputImage, TParentImageFilter >::GPUSuperclass = GPUImageToImageFilter<TInputImage, TOutputImage, TParentImageFilter>

Definition at line 70 of file itkGPUInPlaceImageFilter.h.

## InputImageConstPointer

template<typename TInputImage, typename TOutputImage = TInputImage, typename TParentImageFilter = InPlaceImageFilter<TInputImage, TOutputImage>>

using itk::GPUInPlaceImageFilter< TInputImage, TOutputImage, TParentImageFilter >::InputImageConstPointer = typename InputImageType::ConstPointer

Definition at line 91 of file itkGPUInPlaceImageFilter.h.

## InputImagePixelType

template<typename TInputImage, typename TOutputImage = TInputImage, typename TParentImageFilter = InPlaceImageFilter<TInputImage, TOutputImage>>

using itk::GPUInPlaceImageFilter< TInputImage, TOutputImage, TParentImageFilter >::InputImagePixelType = typename InputImageType::PixelType

Definition at line 93 of file itkGPUInPlaceImageFilter.h.

## InputImagePointer

template<typename TInputImage, typename TOutputImage = TInputImage, typename TParentImageFilter = InPlaceImageFilter<TInputImage, TOutputImage>>

using itk::GPUInPlaceImageFilter< TInputImage, TOutputImage, TParentImageFilter >::InputImagePointer = typename InputImageType::Pointer

Definition at line 90 of file itkGPUInPlaceImageFilter.h.

## InputImageRegionType

template<typename TInputImage, typename TOutputImage = TInputImage, typename TParentImageFilter = InPlaceImageFilter<TInputImage, TOutputImage>>

using itk::GPUInPlaceImageFilter< TInputImage, TOutputImage, TParentImageFilter >::InputImageRegionType = typename InputImageType::RegionType

Definition at line 92 of file itkGPUInPlaceImageFilter.h.

## InputImageType

template<typename TInputImage, typename TOutputImage = TInputImage, typename TParentImageFilter = InPlaceImageFilter<TInputImage, TOutputImage>>

using itk::GPUInPlaceImageFilter< TInputImage, TOutputImage, TParentImageFilter >::InputImageType = TInputImage

Some convenient typedefs.

Definition at line 89 of file itkGPUInPlaceImageFilter.h.

## OutputImagePixelType

template<typename TInputImage, typename TOutputImage = TInputImage, typename TParentImageFilter = InPlaceImageFilter<TInputImage, TOutputImage>>

using itk::GPUInPlaceImageFilter< TInputImage, TOutputImage, TParentImageFilter >::OutputImagePixelType = typename GPUSuperclass::OutputImagePixelType

Definition at line 82 of file itkGPUInPlaceImageFilter.h.

## OutputImagePointer

template<typename TInputImage, typename TOutputImage = TInputImage, typename TParentImageFilter = InPlaceImageFilter<TInputImage, TOutputImage>>

using itk::GPUInPlaceImageFilter< TInputImage, TOutputImage, TParentImageFilter >::OutputImagePointer = typename GPUSuperclass::OutputImagePointer

Definition at line 80 of file itkGPUInPlaceImageFilter.h.

## OutputImageRegionType

template<typename TInputImage, typename TOutputImage = TInputImage, typename TParentImageFilter = InPlaceImageFilter<TInputImage, TOutputImage>>

using itk::GPUInPlaceImageFilter< TInputImage, TOutputImage, TParentImageFilter >::OutputImageRegionType = typename GPUSuperclass::OutputImageRegionType

Definition at line 81 of file itkGPUInPlaceImageFilter.h.

## OutputImageType

template<typename TInputImage, typename TOutputImage = TInputImage, typename TParentImageFilter = InPlaceImageFilter<TInputImage, TOutputImage>>

using itk::GPUInPlaceImageFilter< TInputImage, TOutputImage, TParentImageFilter >::OutputImageType = typename GPUSuperclass::OutputImageType

Superclass typedefs.

Definition at line 79 of file itkGPUInPlaceImageFilter.h.

## Pointer

template<typename TInputImage, typename TOutputImage = TInputImage, typename TParentImageFilter = InPlaceImageFilter<TInputImage, TOutputImage>>

using itk::GPUInPlaceImageFilter< TInputImage, TOutputImage, TParentImageFilter >::Pointer = SmartPointer<Self>

Definition at line 72 of file itkGPUInPlaceImageFilter.h.

## Self

template<typename TInputImage, typename TOutputImage = TInputImage, typename TParentImageFilter = InPlaceImageFilter<TInputImage, TOutputImage>>

using itk::GPUInPlaceImageFilter< TInputImage, TOutputImage, TParentImageFilter >::Self = GPUInPlaceImageFilter

Standard class typedefs.

Definition at line 69 of file itkGPUInPlaceImageFilter.h.

## Constructor & Destructor Documentation

## GPUInPlaceImageFilter()

template<typename TInputImage, typename TOutputImage = TInputImage, typename TParentImageFilter = InPlaceImageFilter<TInputImage, TOutputImage>>

itk::GPUInPlaceImageFilter< TInputImage, TOutputImage, TParentImageFilter >::GPUInPlaceImageFilter | ( |  | ) |

protected default

## ~GPUInPlaceImageFilter()

template<typename TInputImage, typename TOutputImage = TInputImage, typename TParentImageFilter = InPlaceImageFilter<TInputImage, TOutputImage>>

itk::GPUInPlaceImageFilter< TInputImage, TOutputImage, TParentImageFilter >::~GPUInPlaceImageFilter | ( |  | ) |

override protected default

## Member Function Documentation

## AllocateOutputs()

template<typename TInputImage, typename TOutputImage = TInputImage, typename TParentImageFilter = InPlaceImageFilter<TInputImage, TOutputImage>>

void itk::GPUInPlaceImageFilter< TInputImage, TOutputImage, TParentImageFilter >::AllocateOutputs | ( |  | ) |

override protected

The GenerateData method normally allocates the buffers for all of the outputs of a filter. Since InPlaceImageFilter's can use an overwritten version of the input for its output, the output buffer should not be allocated. When possible, we graft the input to the filter to the output. If an InPlaceFilter has multiple outputs, then it would need to override this method to graft one of its outputs and allocate the remaining. If a filter is threaded (i.e. it provides an implementation of ThreadedGenerateData()), this method is called automatically. If an InPlaceFilter is not threaded (i.e. it provides an implementation of GenerateData()), then this method (or equivalent) must be called in GenerateData().

## GetClassName()

template<typename TInputImage, typename TOutputImage = TInputImage, typename TParentImageFilter = InPlaceImageFilter<TInputImage, TOutputImage>>

virtual const char * itk::GPUInPlaceImageFilter< TInputImage, TOutputImage, TParentImageFilter >::GetClassName | ( |  | ) | const

virtual

Run-time type information (and related methods).

Reimplemented from itk::GPUImageToImageFilter< TInputImage, TOutputImage, TParentImageFilter >.

Reimplemented in itk::GPUCastImageFilter< TInputImage, TOutputImage >, itk::GPURecursiveGaussianImageFilter< TInputImage, TOutputImage >, and itk::GPUUnaryFunctorImageFilter< TInputImage, TOutputImage, TFunction, TParentImageFilter >.

## ITK_DISALLOW_COPY_AND_MOVE()

template<typename TInputImage, typename TOutputImage = TInputImage, typename TParentImageFilter = InPlaceImageFilter<TInputImage, TOutputImage>>

itk::GPUInPlaceImageFilter< TInputImage, TOutputImage, TParentImageFilter >::ITK_DISALLOW_COPY_AND_MOVE | ( | GPUInPlaceImageFilter< TInputImage, TOutputImage, TParentImageFilter > |  | ) |

## itkStaticConstMacro() [1/2]

template<typename TInputImage, typename TOutputImage = TInputImage, typename TParentImageFilter = InPlaceImageFilter<TInputImage, TOutputImage>>

itk::GPUInPlaceImageFilter< TInputImage, TOutputImage, TParentImageFilter >::itkStaticConstMacro | ( | InputImageDimension | ,
|  | unsigned int | ,
|  | TInputImage::ImageDimension | )

ImageDimension constants

## itkStaticConstMacro() [2/2]

template<typename TInputImage, typename TOutputImage = TInputImage, typename TParentImageFilter = InPlaceImageFilter<TInputImage, TOutputImage>>

itk::GPUInPlaceImageFilter< TInputImage, TOutputImage, TParentImageFilter >::itkStaticConstMacro | ( | OutputImageDimension | ,
|  | unsigned int | ,
|  | TOutputImage::ImageDimension | )

## PrintSelf()

template<typename TInputImage, typename TOutputImage = TInputImage, typename TParentImageFilter = InPlaceImageFilter<TInputImage, TOutputImage>>

void itk::GPUInPlaceImageFilter< TInputImage, TOutputImage, TParentImageFilter >::PrintSelf | ( | std::ostream & | os,
|  | Indent | indent ) const

override protected

## ReleaseInputs()

template<typename TInputImage, typename TOutputImage = TInputImage, typename TParentImageFilter = InPlaceImageFilter<TInputImage, TOutputImage>>

void itk::GPUInPlaceImageFilter< TInputImage, TOutputImage, TParentImageFilter >::ReleaseInputs | ( |  | ) |

override protected

InPlaceImageFilter may transfer ownership of the input bulk data to the output object. Once the output object owns the bulk data (done in AllocateOutputs()), the input object must release its hold on the bulk data. ProcessObject::ReleaseInputs() only releases the input bulk data when the user has set the ReleaseDataFlag. InPlaceImageFilter::ReleaseInputs() also releases the input that it has overwritten.

See also
  ProcessObject::ReleaseInputs()

Generated on 1768596610 for elastix by 1.15.0 |